static char *strclone(char *s)
{
	int l = strlen(s)+1;
	char *ns = malloc(l);
	memcpy(ns, s, l);
	return ns;
}

#define in_range(d, low, high) (((d) >= low) && ((d) <= high))

#define xdigit(d) \
	(in_range(d, '0', '9') ? (d) - '0' : \
		(in_range(d, 'a', 'f') ? (d) - 'a' + 10 : \
			(in_range(d, 'A', 'F') ? (d) - 'A' + 10 : -1) \
		) \
 )

static int chex(const char *digits)
{
	int d1, d2;
	d1 = xdigit(digits[0]);
	d2 = xdigit(digits[1]);
	if ((d1 < 0) || (d2 < 0))
		return -1;
	return (d1 << 4) + d2;
}

static char *strcloneq(const char *si, char qchar)
{
	char *so, *ret;
	int len, ch;

	len = strlen(si);
	ret = so = malloc(len);
	len -= 2;
	for(si++; len > 0; len--,si++) {
		if (*si == '\\') {
			si++;
			switch(*si) {
				case 'n': *so = '\n'; break;
				case 'r': *so = '\r'; break;
				case 't': *so = '\t'; break;
				case 'x':
					ch = (char)chex(si+1);
					if (ch < 0) {
						free(ret);
						return NULL;
					}
					*so = ch;
					si += 2;
					len -= 2;
					break;
				default: /* for at least ", ' and \ */
					*so = *si;
			}
			len--; 
		}
		else
			*so = *si;
		so++;
	}
	if ((so > ret) && (so[-1] == qchar))
		so[-1] = '\0';
	*so = '\0';
	return ret;
}
