#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <libporty/net/network.h>
#include <libporty/net_async/adns.h>

int main()
{
	P_net_socket dns;
	char line[1024];
	int len, n;
	struct P_pollfd fds[1];
	char *requests[] = {
		"addr IPv4 localhost   cookie1:localhost\n",
		"addr IPv4 nonexst.com cookie2:fail\r\n",
		"name IPv4 127.0.0.1   cookie3:127.0.0.1\r",
		"addr IPv6 nonexst.com cookie4:fail\r",
		NULL
	};
	char **s;

	P_net_init();

	if (P_net_async_dns(&dns) != 0) {
		printf("Failed to create async dns\n");
		P_net_uninit();
		return 1;
	}

	for(s = requests; *s != NULL; s++)
		P_net_write(dns, *s, strlen(*s));

	fds[0].fd     = dns;
	fds[0].events = P_POLLIN;

	for(n = 0; n < 4; n++) {
		P_poll(fds, 1, 4000);
		printf("\n*tick*\n");
		if (fds[0].revents & P_POLLIN) {
			len = P_net_read(dns, line, sizeof(line)-1);
			if (len > 0) {
				line[len] = '\0';
				printf("READ: '%s'\n", line);
			}
		}
	}

	P_net_uninit();
	return 0;
}
